<?php

/**
 * Copyright © 2016 Jaroslav Hranička <hranicka@outlook.com>
 */

namespace Etten\Doctrine\Helpers;

use Ramsey;

class UuidCoverter
{

	public static function binaryToHex($value)
	{
		$uuid = Ramsey\Uuid\Uuid::fromBytes($value);
		return $uuid->getHex();
	}

	public static function binaryToString($value)
	{
		$uuid = Ramsey\Uuid\Uuid::fromBytes($value);
		return $uuid->toString();
	}

	public static function binaryToMySqlEndian($value)
	{
		$string = Ramsey\Uuid\Uuid::fromBytes($value)->toString();
		$parts = explode('-', $string);
		$endian = $parts[2] . $parts[1] . $parts[0] . $parts[3] . $parts[4];

		return "UNHEX('$endian')";
	}

	public static function stringOrHexToMySqlEndian($value)
	{
		$string = Ramsey\Uuid\Uuid::fromString($value)->toString();
		$parts = explode('-', $string);
		$endian = $parts[2] . $parts[1] . $parts[0] . $parts[3] . $parts[4];

		return "UNHEX('$endian')";
	}

	public static function hexToBinary($value)
	{
		$uuid = Ramsey\Uuid\Uuid::fromString($value);
		return $uuid->getBytes();
	}

	public static function stringToBinary($value)
	{
		$uuid = Ramsey\Uuid\Uuid::fromString($value);
		return $uuid->getBytes();
	}

}
